<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta charset="utf-8" />
<meta name="generator" content="Docutils 0.21b.dev: https://docutils.sourceforge.io/" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<meta name="author" content="David Goodger" />
<meta name="dcterms.date" content="$Date$" />
<meta name="dcterms.rights" content="This document has been placed in the public domain." />
<title>Inside A Docutils Command-Line Front-End Tool</title>
<link rel="schema.dcterms" href="http://purl.org/dc/terms/"/>
<link rel="stylesheet" href="../../docutils/writers/html5_polyglot/minimal.css" type="text/css" />
<link rel="stylesheet" href="../../docutils/writers/html5_polyglot/responsive.css" type="text/css" />
</head>
<body>
<header>
<p><a class="reference external" href="https://docutils.sourceforge.io">Docutils</a> | <a class="reference external" href="../index.html">Overview</a> | <a class="reference external" href="../index.html#project-fundamentals">About</a> | <a class="reference external" href="../index.html#user">Users</a> | <a class="reference external" href="../index.html#ref">Reference</a> | <a class="reference external" href="../index.html#howto">Developers</a></p>
</header>
<main id="inside-a-docutils-command-line-front-end-tool">
<h1 class="title">Inside A Docutils Command-Line Front-End Tool</h1>
<dl class="docinfo">
<dt class="author">Author<span class="colon">:</span></dt>
<dd class="author"><p>David Goodger</p></dd>
<dt class="contact">Contact<span class="colon">:</span></dt>
<dd class="contact"><a class="reference external" href="mailto:docutils-develop&#64;lists.sourceforge.net">docutils-develop&#64;lists.sourceforge.net</a></dd>
<dt class="date">Date<span class="colon">:</span></dt>
<dd class="date">$Date$</dd>
<dt class="revision">Revision<span class="colon">:</span></dt>
<dd class="revision">$Revision$</dd>
<dt class="copyright">Copyright<span class="colon">:</span></dt>
<dd class="copyright">This document has been placed in the public domain.</dd>
</dl>
<!-- Minimal menu bar for inclusion in documentation sources
in ``docutils/docs/*/`` sub-diretories.

Attention: this is not a standalone document. -->
<aside class="admonition note">
<p class="admonition-title">Note</p>
<p>This document describes the traditional approach with
hand-crafted front-end scripts.
Since version 0.21, the package installer installs
front-end scripts generated from &quot;console_scripts&quot;
<a class="reference external" href="https://packaging.python.org/en/latest/specifications/entry-points/">entry point</a> definitions.</p>
</aside>
<p><a class="reference external" href="./publisher.html">The Docutils Publisher</a> class was set up to make building
command-line tools easy.  All that's required is to choose components
and supply settings for variations.  Let's take a look at a typical
command-line front-end tool, <span class="docutils literal">tools/rst2html.py</span>, from top to
bottom.</p>
<p>On Unixish systems, it's best to make the file executable (<span class="docutils literal">chmod +x file</span>), and supply an interpreter on the first line, the &quot;shebang&quot; or
&quot;hash-bang&quot; line:</p>
<pre class="literal-block">#!/usr/bin/env python</pre>
<p>Windows systems can be set up to associate the Python interpreter with
the <span class="docutils literal">.py</span> extension.</p>
<p>Next are some comments providing metadata:</p>
<pre class="literal-block"># $Id$
# Author: David Goodger &lt;goodger&#64;python.org&gt;
# Copyright: This module has been placed in the public domain.</pre>
<p>The module docstring describes the purpose of the tool:</p>
<pre class="literal-block">&quot;&quot;&quot;
A minimal front end to the Docutils Publisher, producing HTML.
&quot;&quot;&quot;</pre>
<p>This next block attempts to invoke locale support for
internationalization services, specifically text encoding.  It's not
supported on all platforms though, so it's forgiving:</p>
<pre class="literal-block">try:
    import locale
    locale.setlocale(locale.LC_ALL, '')
except:
    pass</pre>
<p>The real work will be done by the code that's imported here:</p>
<pre class="literal-block">from docutils.core import publish_cmdline, default_description</pre>
<p>We construct a description of the tool, for command-line help:</p>
<pre class="literal-block">description = ('Generates (X)HTML documents from standalone '
               'reStructuredText sources.  ' + default_description)</pre>
<p>Now we call the Publisher convenience function, which takes over.
Most of its defaults are used (&quot;standalone&quot; Reader,
&quot;reStructuredText&quot; Parser, etc.).  The HTML Writer is chosen by name,
and a description for command-line help is passed in:</p>
<pre class="literal-block">publish_cmdline(writer_name='html', description=description)</pre>
<p>That's it!  <a class="reference external" href="./publisher.html">The Docutils Publisher</a> takes care of the rest.</p>
</main>
<footer>
<p><a class="reference external" href="cmdline-tool.txt">View document source</a>.
Generated on: 2023-09-13 17:06 UTC.
Generated by <a class="reference external" href="https://docutils.sourceforge.io/">Docutils</a> from <a class="reference external" href="https://docutils.sourceforge.io/rst.html">reStructuredText</a> source.
</p>
</footer>
</body>
</html>
